require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SYS_UCONTEXT_H)) {
    eval 'sub _SYS_UCONTEXT_H () {1;}' unless defined(&_SYS_UCONTEXT_H);
    require 'features.ph';
    require 'bits/types/sigset_t.ph';
    require 'bits/types/stack_t.ph';
    if(defined(&__USE_MISC)) {
	eval 'sub __ctx {
	    my($fld) = @_;
    	    eval q($fld);
	}' unless defined(&__ctx);
    } else {
	eval 'sub __ctx {
	    my($fld) = @_;
    	    eval q( &__  $fld);
	}' unless defined(&__ctx);
    }
    if( &__GNUC_PREREQ (3, 5)) {
	eval 'sub _SC_GR0_OFFSET () { &__builtin_offsetof ( &mcontext_t,  &__ctx( &sc_gr)[0]);}' unless defined(&_SC_GR0_OFFSET);
    }
 elsif(defined (&__GNUC__)) {
	eval 'sub _SC_GR0_OFFSET () {(( (( &mcontext_t *) 0)-> $__ctx[0]) - 0);}' unless defined(&_SC_GR0_OFFSET);
    } else {
	eval 'sub _SC_GR0_OFFSET () {0xc8;}' unless defined(&_SC_GR0_OFFSET);
    }
    eval 'sub uc_mcontext () { ($_u->{_mc});}' unless defined(&uc_mcontext);
    eval 'sub uc_sigmask () { ($_u->{_mc}->{__ctx})( &sc_mask);}' unless defined(&uc_sigmask);
    eval 'sub uc_stack () { ($_u->{_mc}->{__ctx})( &sc_stack);}' unless defined(&uc_stack);
    eval 'sub uc_link () { ($_u->{_uc}->{_link});}' unless defined(&uc_link);
}
1;
